Subject: bug#63648: 29.0.90; project.el: with switch-use-entire-map, switch-project errors on non-project commands

From: Juri Linkov <[email-masked]>
Date: Sat, 04 Nov 2023 19:28:47 +0200

>>> How about this, then?
>>>
>>> project-switch-use-global-map is obsoleted, all variations are accessible
>>> through customizing project-switch-commands. Should have better
>>> discoverability for project-prefix-or-any-command than simply having it
>>> included.
>> I don't know, it's extra trouble for users to migrate
>> from the obsoleted project-switch-use-entire-map.
>> But maybe ok.
>
> I couldn't find a better alternative to keep the behavior compatible.
>
> Either we have the user customize an existing var (this was the option
> where they'd set project-switch-commands to
> `project-prefix-or-any-command', which you didn't like), or we would add
> a yet another custom var which would, conceptually, conflict with the two
> existing ones.

I don't dislike it.  I proposed a new option project-switch-use-global-map.
But when project-switch-commands should be customized instead of new option,
then I'd prefer to use function names like `project-prefix-or-any-command'
instead of symbols `short-or-any' and `short-keys'.

> Unifying all three alternatives in one option seems like the logical choice.

To avoid obsoleting `project-switch-use-entire-map', `short-keys'
could be removed.  Then `short-or-any' could be replaced by
`project-prefix-or-any-command'.  This will introduce minimal changes.